var os = require('os');

exports.get_private_ips = function(cb){
  var ips = [],
      nics = os.networkInterfaces();

  for (var name in nics) {
    if (name.indexOf('lo') == -1) {
      nics[name].forEach(function(v){
        if (v.family == 'IPv4' && v.address != '127.0.0.1')
          ips.push(v.address);
      })
    }
  }

  if (ips.length == 0)
    cb(new Error('No private IP addresses found.'));
  else
    cb(null, ips);
}

// modified version of http://stackoverflow.com/a/10948908
exports.find_by_key = function (obj, key, fn) {
  var j, key = key || '', obj = obj || {}, keys = key.split("."), 
      sObj = [], ssObj = [], isSelector = !!(keys.length > 0);

  var checker = fn || function() { return true };

  var findKey = function (obj, key) {
    var k;
    for (k in obj) {
      if (k === key && checker(obj, key)) {
        sObj.push(obj[k]);
      } else if (typeof obj[k] == 'object') {
        findKey(obj[k], key);
      }
    }
  };

  if (isSelector) {
    var nKey = keys.shift();
    findKey(obj, nKey);

    while (keys.length > 0) {
      nKey = keys.shift();

      if (sObj.length > 0) {
        ssObj = sObj.slice(0), sObj = [];
        for (j in ssObj) {
          findKey(ssObj[j], nKey);
        }
      }
    }
  } else {
    findKey(obj, key);
  }

  return sObj;
};
